#include <bits/stdc++.h>
using namespace std;
#define int long long

int bfs(const vector<vector<int>> &graf, vector<bool> &presao, int start, const int &cilj, int za, vector<int> &vrednosti) {
    int operacija = 1;
    presao[start] = true;

    queue<int> q;
    q.push(start);

    while(!q.empty()) {
        int od = q.front();
        q.pop();

        for(const auto &odTamo : graf[od]) {
            operacija++;

            if(odTamo == cilj) {
                return operacija;
            }

            if(presao[odTamo]) continue;

            vrednosti[odTamo] += za;
            q.push(odTamo);
            presao[odTamo] = true;
        }
    }

    return -1;
}

struct dogadjaj {
    int tip;
    int od;
    int cilj;
    int za;
};

int32_t main() {
    // ios::sync_with_stdio(false);
    // cin.tie(nullptr);

    int n, q;
    cin >> n >> q;

    vector<vector<int>> graf(n);
    // unordered_set<int> cvorovi(n);
    vector<int> vrednosti(n, 0);

    for(int i = 1; i <= n - 1; i++) {
        int a, b;
        cin >> a >> b;
        graf[a].push_back(b);
        // cvorovi.insert(povezanost.first);
        // cvorovi.insert(povezanost.second);
    }

    for(int i = 1; i < n; i++) {
        cout << i << " = ";
        for(const auto &it : graf[i]) {
            cout << it << " ";
        }
        cout << "\n";
    }

    vector<dogadjaj> pitanja(n);
    for(int i = 0; i < n; i++) {
        dogadjaj tmp;
        cin >> tmp.tip >> tmp.od >> tmp.cilj >> tmp.za;
        pitanja[i] = tmp;
    }

    vector<int> p(n);
    for(int i = 0; i < n; i++) {
        cin >> p[i];
    }

    for(int i = 0; i < n; i++) {
        const dogadjaj tmp = pitanja[i];
        vector<bool> presao(n);
        if(tmp.tip == 2) {
            for(int i = tmp.od; i < tmp.cilj; i++) presao[i] = true;
        }

        const int rez = bfs(graf, presao, tmp.od, tmp.cilj, tmp.za, vrednosti);
        if(rez < p[i]) {
            cout << "-1\n";
        } else {
            cout << rez << "\n";
        }
    }

    return 0;
}