#include <bits/stdc++.h>
using namespace std;
#define int long long
#define MAXN 1e+5
#define INF 1e+15

void bfs(const vector<vector<int>> &graf, vector<bool> &presao, int start, const int &cilj, int za, vector<int> &vrednosti, bool d) {
    presao[start] = true;
    if(!d) {
        vrednosti[start - 1] += za;
    }

    queue<int> q;
    q.push(start);

    while(!q.empty()) {
        int od = q.front();
        q.pop();

        for(const auto &odTamo : graf[od]) {
            vrednosti[odTamo - 1] += za;

            if(cilj != INF && odTamo == cilj) {
                return;
            }

            if(presao[odTamo]) continue;
            q.push(odTamo);
            presao[odTamo] = true;
        }
    }
}

struct dogadjaj {
    int tip;
    int od;
    int cilj;
    int za;
};

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q;
    cin >> n >> q;

    vector<vector<int>> graf(MAXN);
    // unordered_set<int> cvorovi(n);
    vector<int> vrednosti(MAXN, 0);

    for(int i = 1; i <= n - 1; i++) {
        int a, b;
        cin >> a >> b;
        graf[a].push_back(b);
        // cvorovi.insert(povezanost.first);
        // cvorovi.insert(povezanost.second);
    }

    vector<dogadjaj> pitanja(MAXN);

    for(int i = 0; i < n; i++) {
        dogadjaj tmp;
        cin >> tmp.tip >> tmp.od >> tmp.cilj >> tmp.za;
        pitanja[i] = tmp;
    }

    vector<int> p(MAXN);
    for(int i = 0; i < n; i++) {
        cin >> p[i];
    }

    vector<int> odg(MAXN, 0);

    for(int i = 0; i < n; i++) {
        dogadjaj tmp = pitanja[i];
        vector<bool> presao(MAXN, false);

        if(tmp.tip == 2) {
            for(int i = tmp.od; i < tmp.cilj; i++) presao[i] = true;
            tmp.od = tmp.cilj;
            tmp.cilj = INF;
        }

        bfs(graf, presao, tmp.od, tmp.cilj, tmp.za, vrednosti, (tmp.tip == 2) ? true : false);

        for(int a = 0; a < n; a++) {
            if(vrednosti[a] < p[i])
                odg[a]++;
        }
    }

    for(int i = 0; i < n; i++) {
        if(odg[i] < p[i]) {
            cout << "-1 ";
        } else {
            cout << odg[i] << " ";
        }
    }

    return 0;
}