#include <bits/stdc++.h>

using namespace std;
using ll = long long;

vector<int> bfs(int beginNode, vector<vector<int>> &graph) {
    queue<int> red;
    vector<int> poseceni, d(graph.size());

    red.emplace(beginNode);
    int iter = 1;
    while (red.size() > 0) {
        int currentNode = red.front();

        for (int newnode : graph[currentNode]) {
            red.emplace(newnode);
            if (d[newnode] == 0) d[newnode] = iter;
        }

        poseceni.push_back(currentNode);
        red.pop();

        iter++;
    }

    return d;

}

vector<ll> distNodes(ll beginNode, ll dist, vector<vector<ll>> &graph) {
    if (dist == 0) {
        vector<ll> nodes = {beginNode};
        return nodes;
    }

    queue<ll> red;
    vector<ll> poseceni, result;

    red.emplace(beginNode);
    ll iter = 1;
    while (red.size() > 0) {
        ll currentNode = red.front();

        for (ll newnode : graph[currentNode]) {
            red.emplace(newnode);
            if (iter == dist) {
                result.push_back(newnode);
            }
            // if (d[newnode] == 0) d[newnode] = iter;
        }


        poseceni.push_back(currentNode);
        red.pop();

        if (iter == dist) {
            return result;
        }

        // cout << red.size() << endl;

        iter++;
    }

    return result;

}

struct Operacija {
    ll t, u, vd, x;
};

int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullprt);
    
    ll n, q; cin >> n >> q;
    vector<vector<ll>> graph(n);
    for (ll i = 0; i < n; i++) {
        vector<ll> row;
        graph[i] = row;
    }

    vector<ll> cvorovi(n);
    for (ll i = 0; i < n - 1; i++) {
        ll a, b; cin >> a >> b;
        graph[min(a - 1,b - 1)].push_back(max(a - 1,b - 1));
    }

    vector<Operacija> operacije(q);
    for (ll i = 0; i < q; i++) {
        cin >> operacije[i].t >> operacije[i].u >> operacije[i].vd >> operacije[i].x;
    }
    vector<ll> odgovori(n), rez(n);
    for (ll i = 0; i < n; i++) {
        cin >> odgovori[i];
        rez[i] = -1;
    }

    ll iter = 1;
    for (auto operacija : operacije) {
        if (operacija.t == 2) {
            vector<ll> nodes = distNodes(operacija.u - 1, operacija.vd, graph);

            for (auto node : nodes) {
                cvorovi[node] += operacija.x;

                if (cvorovi[node] >= odgovori[node] && rez[node] == -1) {
                    rez[node] = iter;
                }
            }
        }

        iter++;
    }

    for (auto node : rez) {
        cout << node << " ";
    }
    cout << "\n";

    return 0;
}